+
<template lang="pug">
	extends Base.pug
	block valores
		- var titulo = "Imagen"

	block funcion
		.campo
			label Ruta
			//- input(type="url", v-model="url", placeholder="ruta de la imagen")
			input(type="file", @change="fileChange")
		.previo
			figure: img(:src="valor")
		.botones
			button(type="button", @click="crearNuevo") Agregar Imagen

</template>


<script>
import Base from './Base.vue';
import { mapState, mapGetters, mapMutations, mapActions } from 'vuex'

import loadImage from "blueimp-load-image"

export default {
	extends: Base,
	data: () => ({
		valor: ""
	}),
	watch:{
		error(n){
			switch (n){
				case 1:
					this.mensaje = "La ruta está vacía"
				break
			}
		}
	},
	computed:{
		...mapGetters({
			pagina: "contenido/actual"
		}),
	},
	methods:{
		async fileChange(evt){
			console.log(evt.target.files)
			const file = evt.target.files[0]
			// const reader = new FileReader();

			// reader.readAsDataURL(file);
			// reader.onload = () => {
			// 	this.valor = reader.result
			// };
			// reader.onerror = (error) => {
			// 	console.log('Error: ', error);
			// };

			const {image} = await loadImage(file,{
				maxWidth: parseInt(this.pagina.ancho),
				maxHeight: parseInt(this.pagina.alto),
				cover: true,
				canvas: true
			});

			const dataURL = image.toDataURL()
			this.valor = dataURL
		},
		crearNuevo(){
			if (this.valor.length) {

				this.$axios.$post("/imagen", {
					base64: this.valor,
				})
				.then(response => {
					console.log(response);
					this.crear(response.url)

					this.terminado()
				})
				.catch(function (error) {
					console.log(error);
				});

				//this.crear(this.valor)

				//this.terminado()
			}
			else{
				this.error = 1 // Vacío
				this.mensaje = "Valor vacío"
				console.log(this.mensaje)
			}
		},
		...mapActions({
			crear: "editor/crearImagen"
		})
	}

}
</script>

<style lang="stylus">

.previo
	margin-bottom .5rem

input[type="file"]
	color white



</style>
